<?php
//    POS-Tech API
//
//    Copyright (C) 2012 Scil (http://scil.coop)
//
//    This file is part of POS-Tech.
//
//    POS-Tech is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    POS-Tech is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with POS-Tech.  If not, see <http://www.gnu.org/licenses/>.

namespace Pasteque;

$action = $_GET['action'];
$ret = null;

switch ($action) {
case 'get':
    if (!isset($_GET['id'])) {
       $ret = false;
       break;
    }
    $ret = CategoriesService::get($_GET['id']);
    break;
case 'getAll':
    $ret = CategoriesService::getAll();
    break;
case 'create':
    if (!isset($_GET['label'])) {
        $ret = false;
        break;
    }
    $parent = null;
    if (isset($_GET['parent_id'])) {
        $parent = $_GET['parent_id'];
    }
    $cat = new Category($parent, $_GET['label']);
    $ret = CategoriesService::createCat($cat);
    break;
case 'delete':
    if (!isset($_GET['id'])) {
        $ret = false;
        break;
    }
    $ret = CategoriesService::deleteCat($_GET['id']);
    break;
case 'update':
    if (!isset($_GET['id']) || !isset($_GET['label'])
        || !isset($_GET['parent_id'])) {
        $ret = false;
        break;
    }
    $cat = Category::__build($_GET['id'], $_GET['parent_id'], $_GET['label']);
    $ret = CategoriesService::updateCat($cat);
    break;
}

echo(json_encode($ret));

?>
